#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

typedef struct {
   double x;
   double y;
} point;

#define MAX 100

typedef point cpolygon[MAX];

void genPolygon ( cpolygon P, int n )
{
   int i, j;
   double angle[MAX], t;

   for (i=0; i<n; ++i) angle[i] = 2 * M_PI * (double)rand() / (double)RAND_MAX;
   for (i=n-2; i>=0; --i) {
      for (j=0; j<=i; ++j) {
         if (angle[j] > angle[j+1]) {
            t = angle[j];
            angle[j] = angle[j+1];
            angle[j+1] = t;
         }
      }
   }
   for (i=0; i<n; ++i) {
      P[i].x = cos(angle[i]);
      P[i].y = sin(angle[i]);
   }
}

double triangleArea ( cpolygon P, int i, int j, int k )
{
   double a, b, c, s;

   a = sqrt(pow(P[i].x-P[j].x,2)+pow(P[i].y-P[j].y,2));
   b = sqrt(pow(P[j].x-P[k].x,2)+pow(P[j].y-P[k].y,2));
   c = sqrt(pow(P[k].x-P[i].x,2)+pow(P[k].y-P[i].y,2));
   s = (a + b + c) / 2.0;
   return (sqrt(s*(s-a)*(s-b)*(s-c)));
}

double polygonArea ( cpolygon P, int n )
{
   int i;
   double area = 0;

   for (i=1; i<=n-2; ++i) area += triangleArea(P,0,i,i+1);
   return area;
}

int main ()
{
   int n;
   cpolygon P;

   srand((unsigned int)time(NULL));
   n = 3 + rand() % (MAX - 2);
   genPolygon(P,n);
   printf("Polygon has %d vertices\n", n);
   printf("Area of polygon = %lf\n", polygonArea(P,n));
   exit(0);
}
