#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAX 100
#define INFINITY 123456789

void genMat ( int A[][MAX], int m, int n )
{
   int i, j;

   for (i=0; i<m; ++i) {
      A[i][0] = 1 + rand() % 50;
      for (j=1; j<n; ++j) A[i][j] = A[i][j-1] + (1 + rand() % 10);
   }
   for (i=0; i<m; ++i) {
      printf("List %2d:", i);
      for (j=0; j<n; ++j) printf(" %3d", A[i][j]);
      printf("\n");
   }
}

int merge ( int B[], int A[][MAX], int m, int n )
{
   int index[MAX], i, k, min;

   for (i=0; i<m; ++i) index[i] = 0;
   k = 0;
   while (1) {
      min = INFINITY;
      for (i=0; i<m; ++i) {
         if ((index[i] < n) && (A[i][index[i]] < min)) min = A[i][index[i]];
      }
      if (min == INFINITY) return k;
      B[k++] = min;
      for (i=0; i<m; ++i) {
         if ((index[i] < n) && (A[i][index[i]] == min)) ++index[i];
      }
   }
}

void prnList ( int A[], int n )
{
   int i;

   printf("Merged list:");
   for (i=0; i<n; ++i) printf(" %3d", A[i]);
   printf("\n");
}

int main ()
{
   int A[MAX][MAX], B[MAX*MAX], m, n, k;

   srand((unsigned int)time(NULL));
   m = 16; n = 32;
   genMat(A,m,n);
   k = merge(B,A,m,n);
   printf("k = %d\n", k);
   prnList(B,k);
   exit(0);
}
