#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

typedef struct _node {
   int data;
   struct _node *next;
} node;

node *genSeq1 ( int n )
{
   node *L, *p;

   L = (node *)malloc(sizeof(node));
   L -> data = n;
   p = L;
   while (n) {
      n -= (int)sqrt((double)n);
      p -> next = (node *)malloc(sizeof(node));
      p = p -> next;
      p -> data = n;
   }
   p -> next = NULL;
   return L;
}

node *genSeq2 ( node *L1, int n )
{
   node *L2, *p1, *p2;
   p1 = L1;
   while (p1 -> data > n) p1 = p1 -> next;
   if (p1 -> data == n) return p1;
   L2 = (node *)malloc(sizeof(node));
   L2 -> data = n;
   p2 = L2;
   while (1) {
      n -= (int)sqrt((double)n);
      while ((p1 != NULL) && (p1 -> data > n)) p1 = p1 -> next;
      if (p1 -> data == n) {
         p2 -> next = p1;
         return L2;
      }
      p2 -> next = (node *)malloc(sizeof(node));
      p2 = p2 -> next;
      p2 -> data = n;
   }
}

node *getIntersection ( node *L1, node *L2 )
{
   node *p1, *p2;

   p1 = L1; p2 = L2;
   while (1) {
      if (p1 -> data == p2 -> data) return p1;
      else if (p1 -> data > p2 -> data) p1 = p1 -> next;
      else p2 = p2 -> next;
   }
}

void prnList ( node *L )
{
   printf("Sequence: ");
   while (L != NULL) {
      printf("%d ", L -> data);
      L = L -> next;
   }
   printf("\n");
}


int main ()
{
   node *L1, *L2, *L3;

   srand((unsigned int)time(NULL));
   L1 = genSeq1(rand()%1000);
   prnList(L1);
   L2 = genSeq2(L1,rand()%1000);
   prnList(L2);
   L3 = getIntersection(L1,L2);
   prnList(L3);
   exit(0);
}
